﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace szojatek
{
    class Szo5
    {
        public string Szó { get; set; }
        public string Fok { get; set; }
        public Szo5(string szó)
        {
            Szó = szó;
            Fok = szó.Substring(1, 3);
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            #region 1. feladat bekért szó magánhangzóinak száma
            Console.Write("1. feladat: Adjon meg egy szót: ");
            string egyszó = Console.ReadLine();
            Console.WriteLine((egyszó.Contains('a') || egyszó.Contains('e') || egyszó.Contains('i') || egyszó.Contains('o') || egyszó.Contains('u')) ?
                "Van benne magánhangzó" : "Nincs benne magánhangzó");
            #endregion
            #region 2-4. feladat fájlbeolvasás tárolás nélkül
            int maxLength = 0;
            string maxSzó = "";
            int db = 0;
            int sokmagán = 0;
            List<Szo5> létra = new List<Szo5>();
            using (System.IO.StreamReader sr = new System.IO.StreamReader("szoveg.txt"))
            {
                System.IO.StreamWriter temp = new System.IO.StreamWriter("letra.txt");

                while (!sr.EndOfStream)
                {
                    string adat = sr.ReadLine();
                    //2. feladathoz - leghosszabb szó
                    if (adat.Length > maxLength)
                    {
                        maxLength = adat.Length;
                        maxSzó = adat;
                    }
                    //3. feladathoz - magánhangzók aránya
                    db++;
                    int mh = 0;
                    string aeiou = "aeiou";
                    foreach (char ch in adat)
                    {
                        if (aeiou.Contains(ch))
                        {
                            mh++;
                        }
                    }
                    if (mh * 2 > adat.Length)
                    {
                        temp.Write(adat + " ");
                        sokmagán++;
                    }
                    //4. feladathoz - 5 hosszúságú szavak gyűjtése
                    if (adat.Length == 5)
                    {
                        létra.Add(new Szo5(adat));
                    }
                }
                temp.Close();
                sr.Close();
            }
            #endregion
            #region 2-4 feladatok eredménye
            Console.WriteLine("2. feladat: \tA leghosszabb szó: {0} \t karaktereinek száma: {1}", maxSzó, maxLength);
            Console.WriteLine("3. feladat");
            using (System.IO.StreamReader sr = new System.IO.StreamReader("letra.txt"))
            {
                Console.WriteLine(sr.ReadToEnd());
                sr.Close();
            }
            Console.WriteLine("{0}/{1} : {2:P2}", sokmagán, db, (double) sokmagán/db);
            Console.Write("4. feladat: Adja meg a 3 karakteres szórészletet: ");
            string fok = Console.ReadLine();
            foreach (Szo5 elem in létra)
            {
                if (elem.Fok.CompareTo(fok) == 0)
                {
                    Console.Write(elem.Szó + " ");
                }
            }
            #endregion;
            #region 5. feladat - létra rendezett kiírása
            for (int i = 0; i < létra.Count -1; i++)
            {
                int min = i;
                for (int j = létra.Count-1 ; j >= i; j--)
                {
                    if (létra[j].Fok.CompareTo(létra[min].Fok) == -1)
                    {
                        min = j;
                    }
                }
                Szo5 cs = létra[i];
                létra[i] = létra[min];
                létra[min] = cs;
                
            }

            using(System.IO.StreamWriter sw = new System.IO.StreamWriter("letra.txt"))
            {
                int tól = 0;
                int ig = 0;
                int i = 0;
                while (i < létra.Count)
                {
                    while (ig < létra.Count && létra[tól].Fok == létra[ig].Fok)
                    {
                        ig++;
                    }
                    if (tól < ig-1)
                    {
                        for (int j = tól; j < ig; j++)
                        {
                            sw.WriteLine(létra[j].Szó);
                        }
                        sw.WriteLine();
                    }
                    i = ig;
                    tól = ig;
                }
                
                sw.Close();
            }
            #endregion

            Console.ReadKey();
        }
    }
}
